"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
function ease(_ref) {
  var _ref$startValue = _ref.startValue,
      startValue = _ref$startValue === undefined ? 0 : _ref$startValue,
      _ref$endValue = _ref.endValue,
      endValue = _ref$endValue === undefined ? 1 : _ref$endValue,
      _ref$durationMs = _ref.durationMs,
      durationMs = _ref$durationMs === undefined ? 200 : _ref$durationMs,
      onStep = _ref.onStep,
      _ref$onComplete = _ref.onComplete,
      onComplete = _ref$onComplete === undefined ? function () {} : _ref$onComplete;

  var stepCount = durationMs / 16;
  var valueIncrement = (endValue - startValue) / stepCount;
  var sinValueIncrement = Math.PI / stepCount;
  var currentValue = startValue;
  var currentSinValue = 0;

  function step() {
    currentSinValue += sinValueIncrement;
    currentValue += valueIncrement * Math.pow(Math.sin(currentSinValue), 2) * 2;

    if (currentSinValue < Math.PI) {
      onStep(currentValue);
      window.requestAnimationFrame(step);
    } else {
      onStep(endValue);
      onComplete();
    }
  }

  window.requestAnimationFrame(step);
}

exports.default = ease;